kio Library: KIO::TCPSlaveBase Class Reference (kio Library)

| # kio Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Namespaces | Source Files

# KIO::TCPSlaveBase Class Reference

There are two classes that specifies the protocol between application (job) and kioslave. More...

`#include <tcpslavebase.h>`

Inheritance diagram for KIO::TCPSlaveBase:

[legend]
Collaboration diagram for KIO::TCPSlaveBase:

[legend]
List of all members.

## Public Member Functions
| TCPSlaveBase (unsigned short int defaultPort, const QCString &protocol, const QCString &poolSocket, const QCString &appSocket)
| TCPSlaveBase (unsigned short int defaultPort, const QCString &protocol, const QCString &poolSocket, const QCString &appSocket, bool useSSL)
## Protected Member Functions
KDE_DEPRECATED ssize_t | Write (const void *data, ssize_t len)
KDE_DEPRECATED ssize_t | Read (void *data, ssize_t len)
KDE_DEPRECATED ssize_t | ReadLine (char *data, ssize_t len)
KDE_DEPRECATED unsigned short int | GetPort (unsigned short int p)
KDE_DEPRECATED bool | ConnectToHost (const QString &host, unsigned int port, bool sendError)
KDE_DEPRECATED void | CloseDescriptor ()
KDE_DEPRECATED bool | AtEOF ()
KDE_DEPRECATED bool | InitializeSSL ()
KDE_DEPRECATED void | CleanSSL ()
ssize_t | write (const void *data, ssize_t len)
ssize_t | read (void *data, ssize_t len)
ssize_t | readLine (char *data, ssize_t len)
void | setBlockSize (int sz)
unsigned short int | port (unsigned short int _port)
bool | connectToHost (const QString &host, unsigned int port, bool sendError=true)
bool | usingSSL () const
bool | usingTLS () const
bool | usingTLS ()
bool | canUseTLS ()
int | startTLS ()
void | stopTLS ()
void | closeDescriptor ()
bool | atEnd ()
void | setSSLMetaData ()
bool | initializeSSL ()
void | cleanSSL ()
bool | isConnectionValid ()
int | connectResult ()
bool | waitForResponse (int t)
void | setBlockConnection (bool b)
void | setConnectTimeout (int t)
bool | isSSLTunnelEnabled ()
void | setEnableSSLTunnel (bool enable)
void | setRealHost (const QString &realHost)
void | doConstructorStuff ()
int | verifyCertificate ()
void | certificatePrompt ()
bool | userAborted () const
virtual void | virtual_hook (int id, void *data)
## Protected Attributes
int | m_iSock
bool | m_bIsSSL
unsigned short int | m_iPort
unsigned short int | m_iDefaultPort
QCString | m_sServiceName
FILE * | fp

## Detailed Description

There are two classes that specifies the protocol between application (job) and kioslave.

SlaveInterface is the class to use on the application end, SlaveBase is the one to use on the slave end.

Slave implementations should simply inherit SlaveBase

A call to foo() results in a call to slotFoo() on the other end.

Definition at line 45 of file tcpslavebase.h.

## Member Function Documentation

KDE_DEPRECATED ssize_t KIO::TCPSlaveBase::Write | ( | const void * | data,
|  | ssize_t | len
| ) | `[inline, protected]`

| Deprecated: Due to inconsistency with KDE naming convention. Definition at line 63 of file tcpslavebase.h.

KDE_DEPRECATED ssize_t KIO::TCPSlaveBase::Read | ( | void * | data,
|  | ssize_t | len
| ) | `[inline, protected]`

| Deprecated: Due to inconsistency with KDE naming convention. Definition at line 68 of file tcpslavebase.h.

KDE_DEPRECATED ssize_t KIO::TCPSlaveBase::ReadLine | ( | char * | data,
|  | ssize_t | len
| ) | `[inline, protected]`

| Deprecated: Due to inconsistency with KDE naming convention. Definition at line 73 of file tcpslavebase.h.

KDE_DEPRECATED unsigned short int KIO::TCPSlaveBase::GetPort | ( | unsigned short int | p | ) | `[inline, protected]`

| Deprecated: Due to inconsistency with KDE naming convention. Definition at line 78 of file tcpslavebase.h.

KDE_DEPRECATED bool KIO::TCPSlaveBase::ConnectToHost | ( | const QString & | host,
|  | unsigned int | port,
|  | bool | sendError
| ) | `[inline, protected]`

| Deprecated: Due to inconsistency with KDE naming convention. Definition at line 83 of file tcpslavebase.h.

KDE_DEPRECATED void KIO::TCPSlaveBase::CloseDescriptor | ( |  | ) | `[inline, protected]`

| Deprecated: Due to inconsistency with KDE naming convention. Definition at line 89 of file tcpslavebase.h.

KDE_DEPRECATED bool KIO::TCPSlaveBase::AtEOF | ( |  | ) | `[inline, protected]`

| Deprecated: Due to inconsistency with KDE naming convention. Definition at line 94 of file tcpslavebase.h.

KDE_DEPRECATED bool KIO::TCPSlaveBase::InitializeSSL | ( |  | ) | `[inline, protected]`

| Deprecated: Due to inconsistency with KDE naming convention. Definition at line 99 of file tcpslavebase.h.

KDE_DEPRECATED void KIO::TCPSlaveBase::CleanSSL | ( |  | ) | `[inline, protected]`

| Deprecated: Due to inconsistency with KDE naming convention. Definition at line 104 of file tcpslavebase.h.

ssize_t KIO::TCPSlaveBase::write | ( | const void * | data,
|  | ssize_t | len
| ) | `[protected]`

  | This function acts like standard write function call except it is also capable of making SSL or SOCKS connections. Parameters:
  | data | info to be sent to remote machine
  | len | the length of the data to be sent
Returns: the actual size of the data that was sent

ssize_t KIO::TCPSlaveBase::read | ( | void * | data,
|  | ssize_t | len
| ) | `[protected]`

  | This function acts like standard read function call except it is also capable of deciphering SSL data as well as handling data over SOCKSified connections. Parameters:
  | data | storage for the info read from server
  | len | lenght of the info to read from the server
Returns: the actual size of data that was obtained

ssize_t KIO::TCPSlaveBase::readLine | ( | char * | data,
|  | ssize_t | len
| ) | `[protected]`

| Same as above except it reads data one line at a time.

void KIO::TCPSlaveBase::setBlockSize | ( | int | sz | ) | `[protected]`

| Sets the maximum size of blocks read in during calls to readLine(). This allows a slave to optimize for the protocol which it implements. Ideally this should be (common_line_length+1) or so. Making this too large will have adverse effects on performance. Initial/default value is 256(bytes)

unsigned short int KIO::TCPSlaveBase::port | ( | unsigned short int | _port | ) | `[protected]`

  | Determines the appropriate port to use. This functions attempts to discover the appropriate port. Parameters:
  | _port | the port to try, if it works, it is returned
Returns: the default port if the given port doesn't work

bool KIO::TCPSlaveBase::connectToHost | ( | const QString & | host,
|  | unsigned int | port,
|  | bool | sendError = `true`
| ) | `[protected]`

  | Performs the initial TCP connection stuff and/or SSL handshaking as necessary. Please note that unlike its deprecated counterpart, this function allows you to disable any error message from being sent back to the calling application! You can then use the connectResult() function to determine the result of the request for connection. Parameters:
  | host | hostname
  | port | port number
  | sendError | if true sends error message to calling app.
Returns: on succes, true is returned. on failure, false is returned and an appropriate error message is send to the application.

bool KIO::TCPSlaveBase::usingSSL | ( |  | ) | const`[inline, protected]`

| Are we using SSL? Returns: if so, true is returned. if not, true isn't returned. Since: 3.2 Definition at line 183 of file tcpslavebase.h.

bool KIO::TCPSlaveBase::usingTLS | ( |  | ) | const`[protected]`

| Are we using TLS? Returns: if so, true is returned. if not, true isn't returned. Since: 3.2

bool KIO::TCPSlaveBase::usingTLS | ( |  | ) | `[protected]`

| Deprecated: kept for binary compatibility Are we using TLS? Returns: if so, true is returned. if not, true isn't returned.

bool KIO::TCPSlaveBase::canUseTLS | ( |  | ) | `[protected]`

| Can we use TLS? Returns: if so, true is returned. if not, true isn't returned.

int KIO::TCPSlaveBase::startTLS | ( |  | ) | `[protected]`

| Start using TLS on the connection. Returns: on success, 1 is returned. on failure, 0 is returned. on TLS init failure, -1 is returned. on connect failure, -2 is returned. on certificate failure, -3 is returned.

void KIO::TCPSlaveBase::stopTLS | ( |  | ) | `[protected]`

| Stop using TLS on the connection.

void KIO::TCPSlaveBase::closeDescriptor | ( |  | ) | `[protected]`

| Closes the current file descriptor. Call this function to properly close up the socket since it also takes care to prroperly close the stdio fstream stuff, as well as sets the socket back to -1

bool KIO::TCPSlaveBase::atEnd | ( |  | ) | `[protected]`

| Returns true when end of data is reached.

void KIO::TCPSlaveBase::setSSLMetaData | ( |  | ) | `[protected]`

| Call this if you use persistent connections and want all the metadata restored. This is particularly important for SSL sessions since the app needs to know the state of connection, certificates, etc.

bool KIO::TCPSlaveBase::initializeSSL | ( |  | ) | `[protected]`

| Initializs all SSL variables.

void KIO::TCPSlaveBase::cleanSSL | ( |  | ) | `[protected]`

| Cleans up all SSL settings.

bool KIO::TCPSlaveBase::isConnectionValid | ( |  | ) | `[protected]`

| Determines whether or not we are still connected to the remote machine. This method may fail to detect a closed SSL connection. return `true` if the socket is still active or false otherwise.

int KIO::TCPSlaveBase::connectResult | ( |  | ) | `[protected]`

| Returns the status of the connection. This function allows you to invoke ConnectToHost with the `sendError` flag set to false so that you can send the appropriate error message back to the calling io-slave. Returns: the status code as returned by KExtendedSocket.

bool KIO::TCPSlaveBase::waitForResponse | ( | int | t | ) | `[protected]`

  | Wait for some type of activity on the socket for the period specified by `t`. Parameters:
  | t | length of time in seconds that we should monitor the socket before timing out.
Returns: true if any activity was seen on the socket before the timeout value was reached, false otherwise.

void KIO::TCPSlaveBase::setBlockConnection | ( | bool | b | ) | `[protected]`

  | Sets the mode of the connection to blocking or non-blocking. Be sure to call this function before calling connectToHost. Otherwise, this setting will not have any effect until the next `connectToHost`. Parameters:
  | b | true to make the connection a blocking one, false otherwise.

void KIO::TCPSlaveBase::setConnectTimeout | ( | int | t | ) | `[protected]`

  | Sets how long to wait for orignally connecting to the requested before timinig out. Be sure to call this function before calling ConnectToHost, otherwise the setting will not take effect until the next call to `ConnectToHost`. Parameters:
  | t | timeout value

bool KIO::TCPSlaveBase::isSSLTunnelEnabled | ( |  | ) | `[protected]`

| Returns true if SSL tunneling is enabled. See also: setEnableSSlTunnel

void KIO::TCPSlaveBase::setEnableSSLTunnel | ( | bool | enable | ) | `[protected]`

  | Set up SSL tunneling mode. Calling this function with a `true` argument will allow you to temprarly ignore the `m_bIsSSL` flag setting and make a non-SSL connection. It is mostly useful for making connections to SSL sites through a non-transparent proxy server (i.e. most proxy servers out there). Note that once you have successfully "tunneled" through the proxy server you must call this function with its argument set to false to properly connect to the SSL site. Parameters:
  | enable | if true SSL Tunneling will be enabled

void KIO::TCPSlaveBase::setRealHost | ( | const QString & | realHost | ) | `[protected]`

  | Sets up the the real hostname for an SSL connection that goes through a proxy server. This function is essential in making sure that the real hostname is used for validating certificates from SSL sites! Parameters:
  | realHost | the actual host name we are connecting to

The documentation for this class was generated from the following file:

- tcpslavebase.h

This file is part of the documentation for kio Library Version 3.4.1.
Documentation copyright © 1996-2004 the KDE developers.
Generated on Sat Jun 11 20:27:17 2005 by doxygen 1.4.1 written by Dimitri van Heesch, © 1997-2003